unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    FProjectName:string;
  public
  end;

var
  Form1: TForm1;

implementation
uses strutils;
{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  _tempList:TStringList;
  _ProjectName:string;
begin
  _ProjectName:='project1';    // <--- here we have a local variable
  _tempList:=TStringList.create;
  try
    _tempList.add('\gen\com\pascal\lcltest');
    _tempList.Text := AnsiReplaceText(_tempList.Text, 'com\pascal\lcltest','com\pascal\'+ _ProjectName);
    memo1.Lines.assign(_tempList);
  finally
    _tempList.free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  _tempList:TStringList;
begin
  FProjectName:='project1';   // <--- here we have a Field-Variable of TForm
  _tempList:=TStringList.create;
  try
    _tempList.add('\gen\com\pascal\lcltest');
    _tempList.Text := AnsiReplaceText(_tempList.Text, 'com\pascal\lcltest','com\pascal\'+ FProjectName);
    memo2.Lines.assign(_tempList);
  finally
    _tempList.free;
  end;
end;

end.

